#ifndef EFL_CANVAS_TEXT_EO_HH
#define EFL_CANVAS_TEXT_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_animator.eo.h"
#include "efl_canvas_object.eo.h"
#include "efl_canvas_text.eo.h"
#include "efl_canvas_text_cursor.eo.h"
#include "efl_event_hold.eo.h"
#include "efl_event_key.eo.h"
#include "efl_event_pointer.eo.h"
#include "efl_gfx.eo.h"
#include "efl_gfx_map.eo.h"
#include "efl_gfx_size_hint.eo.h"
#include "efl_gfx_stack.eo.h"
#include "efl_input_interface.eo.h"
#include "efl_text.eo.h"
#include "eo_base.eo.h"
#include "eo_interface.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_animator.eo.hh"
#include "efl_canvas_object.eo.hh"
#include "efl_canvas_text_cursor.eo.hh"
#include "efl_event_hold.eo.hh"
#include "efl_event_key.eo.hh"
#include "efl_event_pointer.eo.hh"
#include "efl_gfx.eo.hh"
#include "efl_gfx_map.eo.hh"
#include "efl_gfx_size_hint.eo.hh"
#include "efl_gfx_stack.eo.hh"
#include "efl_input_interface.eo.hh"
#include "efl_text.eo.hh"
#include "eo_base.eo.hh"
#include "eo_interface.eo.hh"
namespace efl { namespace canvas { 
struct Text;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::canvas::Text> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace canvas { 
struct Text {
    ::efl::eina::string_view bidi_delimiters_get() const;
   void bidi_delimiters_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type delim) const;
   bool legacy_newline_get() const;
   void legacy_newline_set( ::efl::eolian::in_traits<bool>::type mode) const;
    ::efl::eina::string_view style_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key) const;
   void style_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type style) const;
   void size_formatted_get( ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
    ::efl::canvas::text::Cursor cursor_get() const;
   void size_native_get( ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
   void style_insets_get( ::efl::eolian::out_traits<Evas_Coord>::type l,  ::efl::eolian::out_traits<Evas_Coord>::type r,  ::efl::eolian::out_traits<Evas_Coord>::type t,  ::efl::eolian::out_traits<Evas_Coord>::type b) const;
   bool is_empty_get() const;
   bool obstacle_add( ::efl::eolian::in_traits< ::efl::canvas::Object>::type eo_obs) const;
   bool obstacle_del( ::efl::eolian::in_traits< ::efl::canvas::Object>::type eo_obs) const;
   void obstacles_update() const;
    ::efl::eina::iterator<Eina_Rectangle> range_geometry_get( ::efl::eolian::in_traits< ::efl::canvas::text::Cursor>::type cur1,  ::efl::eolian::in_traits< ::efl::canvas::text::Cursor>::type cur2) const;
   void range_delete( ::efl::eolian::in_traits< ::efl::canvas::text::Cursor>::type cur1,  ::efl::eolian::in_traits< ::efl::canvas::text::Cursor>::type cur2) const;
   bool visible_range_get( ::efl::eolian::in_traits< ::efl::canvas::text::Cursor>::type start,  ::efl::eolian::in_traits< ::efl::canvas::text::Cursor>::type end) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_CANVAS_TEXT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::canvas::Text() const;
   operator ::efl::canvas::Text&();
   operator ::efl::canvas::Text const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Text,  ::efl::Animator,  ::efl::Gfx,  ::efl::Text,  ::efl::canvas::Object,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Text const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::Text const ,  ::efl::canvas::Object const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace canvas { 
struct Text : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Animator)
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl::Text)
   , EO_CXX_INHERIT( ::efl ::canvas::Object)
   , EO_CXX_INHERIT( ::efl ::gfx::Map)
   , EO_CXX_INHERIT( ::efl ::gfx::Stack)
   , EO_CXX_INHERIT( ::efl ::gfx ::size::Hint)
   , EO_CXX_INHERIT( ::efl ::input::Interface)
   , EO_CXX_INHERIT( ::eo::Base)
   , EO_CXX_INHERIT( ::eo::Interface)
{
   explicit Text( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Text(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Text(Text const& other) = default;
   Text(Text&& other) = default;
   Text& operator=(Text const& other) = default;
   Text& operator=(Text&& other) = default;
   Text()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Text( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Text(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
    ::efl::eina::string_view bidi_delimiters_get() const;
   void bidi_delimiters_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type delim) const;
   bool legacy_newline_get() const;
   void legacy_newline_set( ::efl::eolian::in_traits<bool>::type mode) const;
    ::efl::eina::string_view style_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key) const;
   void style_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type style) const;
   void size_formatted_get( ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
    ::efl::canvas::text::Cursor cursor_get() const;
   void size_native_get( ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
   void style_insets_get( ::efl::eolian::out_traits<Evas_Coord>::type l,  ::efl::eolian::out_traits<Evas_Coord>::type r,  ::efl::eolian::out_traits<Evas_Coord>::type t,  ::efl::eolian::out_traits<Evas_Coord>::type b) const;
   bool is_empty_get() const;
   bool obstacle_add( ::efl::eolian::in_traits< ::efl::canvas::Object>::type eo_obs) const;
   bool obstacle_del( ::efl::eolian::in_traits< ::efl::canvas::Object>::type eo_obs) const;
   void obstacles_update() const;
    ::efl::eina::iterator<Eina_Rectangle> range_geometry_get( ::efl::eolian::in_traits< ::efl::canvas::text::Cursor>::type cur1,  ::efl::eolian::in_traits< ::efl::canvas::text::Cursor>::type cur2) const;
   void range_delete( ::efl::eolian::in_traits< ::efl::canvas::text::Cursor>::type cur1,  ::efl::eolian::in_traits< ::efl::canvas::text::Cursor>::type cur2) const;
   bool visible_range_get( ::efl::eolian::in_traits< ::efl::canvas::text::Cursor>::type start,  ::efl::eolian::in_traits< ::efl::canvas::text::Cursor>::type end) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_CANVAS_TEXT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Text,  ::efl::Animator,  ::efl::Gfx,  ::efl::Text,  ::efl::canvas::Object,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Text const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::Text const ,  ::efl::canvas::Object const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Text) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Text>::value, "");
} } 
#include "efl_canvas_text.eo.impl.hh"
#endif
